part of responsive_data_table;

mixin DataTableFilter<T> on Widget {
  /// The current value
  T get value;

  /// callback when value changed
  ValueChanged<T> get onChange;
}

mixin DecoratedDataTableFilter<T> implements DataTableFilter<T> {
  InputDecoration get decoration;

  InputDecoration _effectiveDecoration(BuildContext context,
      String Function(ReadyListLocalizations tr) display) {
    var result = this.decoration is _DefaultInputDecoration
        ? this
            .decoration
            .copyWith(hintText: display(Ready.localization(context)))
        : decoration;

    return result.applyDefaults(Theme.of(context).inputDecorationTheme);
  }
}
